/**
 * Copyright 2019 DH
 * All right reserved.
 * 项目名称: 大恒泰山系统
 * 创建日期:2021/12/16
 */
package org.ts.ddcs.dataStream.processor.szy;


import lombok.extern.slf4j.Slf4j;
import org.ts.ddcs.enums.SzyElementCodeEnum;
import org.ts.ddcs.common.metadata.ElementDataMetadataEnum;
import org.ts.ddcs.common.metadata.JsonPackMetadataEnum;
import org.ts.ddcs.enums.SzyDatagramTypeCodeEnum;
import org.ts.ddcs.common.util.BytesHelp;
import org.ts.ddcs.dataStream.DataStreamAdapter;
import org.ts.ddcs.dataStream.DataStreamCache;
import org.ts.ddcs.dataStream.DataStreamLineManager;
import org.ts.ddcs.dataStream.DataStreamProcessor;
import org.ts.ddcs.datatemplate.TestState;
import org.ts.ddcs.metadata.DataStreamCacheMetadata;

import java.util.*;

/***
 * Date:2021/12/16
 * Title:水资源规约数据处理器模块
 * Description：水资源 设置IP 0x10
 * @author dylan
 * @version 1.0
 * Remark：认为有必要的其他信息
 */
@Slf4j
public class DataStreamSzySetRtuCodeDatagramProcessor extends DataStreamProcessor {

    private DataStreamCache dataStreamCache;
    private Map<String, List<Map<String, Object>>> keyStore = new HashMap<>();

    @Override
    public void init(DataStreamLineManager context) {
        this.context = context;
        this.dataStreamCache = context.getCache();
    }

    @Override
    public void process(DataStreamAdapter dataStreamAdapter) {
        this.dataStreamCache.setState(TestState.MATHCE);
        this.dataStreamCache.setMatchProcessor(this);
        String datagramCode = this.dataStreamCache.getDatagramCode();
        if (SzyDatagramTypeCodeEnum.DATAGRAM_CODE_10.getName().equals(datagramCode)) {

            byte[] dataArea = this.dataStreamCache.getBytesValue(DataStreamCacheMetadata.METADATA_DATA_AREA.getName());
            int count = 0;
            String setRtuCode = BytesHelp.byte2HexStr(BytesHelp.subBytes(dataArea, count, 5));
            count += 5;
            byte[] pw = BytesHelp.subBytes(dataArea, count, 2);
            count += 2;
            byte[] tm = BytesHelp.subBytes(dataArea, count, 4);
            count += 4;
            byte[] delay = BytesHelp.subBytes(dataArea, count, 1);
            count += 1;

            Map<String, Object> value = new HashMap<>();
            value.put(ElementDataMetadataEnum.ELEMENT_METADATA_CODE.getName(), SzyElementCodeEnum.CODE_EXT_ST.getCode());
            value.put(ElementDataMetadataEnum.ELEMENT_METADATA_NAME.getName(), SzyElementCodeEnum.CODE_EXT_ST.getName());
            value.put(ElementDataMetadataEnum.ELEMENT_METADATA_UNIT.getName(), "");
            value.put(ElementDataMetadataEnum.ELEMENT_METADATA_DESC.getName(), "测站编码");
            value.put(ElementDataMetadataEnum.ELEMENT_METADATA_VALUE.getName(), setRtuCode);

            List<Map<String, Object>> list = new ArrayList<>();
            list.add(value);
            this.keyStore.put(SzyElementCodeEnum.CODE_EXT_ST.getCode(), list);
            this.next(false);
        } else {
            this.next(true);
        }
    }

    @Override
    public void close(DataStreamAdapter dataStreamAdapter) {

    }

    @Override
    public void batchComplete(DataStreamAdapter dataStreamAdapter) {
        log.info("接收到水资源 10 设置终端地址");

    }

    @Override
    public List<Map<String, Object>> sink(DataStreamAdapter dataStreamAdapter) {
        List<Map<String, Object>> datas = new ArrayList<>();
        Map<String, Object> data = new HashMap<>();
        data.put(JsonPackMetadataEnum.PACK_METADATA_DATAGRAM.getName(), BytesHelp.byte2HexStr(this.dataStreamCache.getDatagramBuff()));
        data.put(JsonPackMetadataEnum.PACK_METADATA_FROM_TIME.getName(), this.dataStreamCache.getStringValue(DataStreamCacheMetadata.METADATA_PICK_TIME.getName()));
        data.put(JsonPackMetadataEnum.PACK_METADATA_RTU_CODE.getName(), this.dataStreamCache.getRtuCode());
        datas.add(data);
        return datas;
    }

}
